/*
 * Copyright (c) 2004 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-getgroup.c,v 1.1 2004/04/06 21:32:50 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/test.h"
#include "sm/io.h"
#include <grp.h>

static void
test(char *group)
{
	struct group *grp;

	grp = getgrnam(group);
	SM_TEST(grp != NULL);
	if (grp == NULL)
		return;
	sm_io_fprintf(smioout, "%d\n", grp->gr_gid);
	return;
}

int
main(int argc, char *argv[])
{
	int c;

#if 0
	while ((c = getopt(argc, argv, "d")) != -1)
	{
		switch (c)
		{
		  default:
			usage(argv[0]);
			return EX_USAGE;
		}
	}
#endif /* 0 */

	sm_test_begin(argc, argv, "test getgroup");
	for (c = 1; c < argc; c++)
		test(argv[c]);
	sm_io_flush(smioout);
	return sm_test_end();
}
