/*
 * Copyright (c) 2004, 2005 Sendmail, Inc. and its suppliers.
 *      All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: qmgrdef.h,v 1.12 2005/06/07 22:17:05 ca Exp $
 */

#ifndef SM_QMGRDEF_H
#define SM_QMGRDEF_H 1

#include "sm/generic.h"
#include "sm/units.h"

/*
**  Various defaults for QMGR (esp. configuration).
**  Note: if these values are changed than test programs that use -F
**  need to be changed too!
*/

#define QCNF_FL_NONE		0x00000000
#define QCNF_FL_SE_REUSE	0x00000001	/* try to reuse sessions */
#define QCNF_FL_NO_SCHED	0x00000002	/* no scheduler (testing!) */
/* 4: free */
#define QCNF_FL_B_HDR		0x00000008	/* bounce: headers only */
#define QCNF_FL_B_DSN_MIME	0x00000010	/* bounce in MIME format */

/* bounce: first body, then headers */
#define QCNF_FL_B_BODY_HDR	0x00000020

/* config values (tunable) */
#define IQDB_CSIZE	1023	/* incoming edb size (rsc) */
#define IQDB_HTSIZE	2111	/* incoming edb size (bht) */
#define IBDB_SIZE	65536	/* backup edb size */
#define OCC_CSIZE	2111	/* outgoing connection cache size (rsc) */
#define AQ_SIZE		4096	/* default size of aq */

/* Maximum time in queue (DEFED) */
#define QM_TMO_RETURN	345600
#define QM_TMO_DELAY	3600

/* Maximum time in AQ (waiting for AR), must be larger than DNS timeout... */
#define AQR_AR_TMOUT	120u

/*
**  Maximum time in AQ (waiting for DA result).
**  Could be a long mail, should be larger than the sum of all DA timeouts.
**  Maybe something like size of mail * min. transfer rate needs to be added.
*/

#define AQR_DA_TMOUT	600u

/* Maximum time in AQ (waiting to be scheduled). */
#define AQR_SCHED_TMOUT	600u

/* Maximum time for a DSN to wait to be scheduled  */
#define QM_TMO_SCHED_DSN	1u

/*
**  Delay time for scheduler for a destination for which the concurrency limit
**  is exceeded.
*/

#define QM_DELAY_TOO_MANY 300

/* Time between cleanup runs for DEFEDB */
#define EDB_SWEEP_DELAY	600

/* min free disk space (KB) */
#define DISK_MIN_FREE	16 UNIT_MB
#define DISK_OK_FREE	32 UNIT_MB

#define SM_QMGR_MIN_THR	2
#define SM_QMGR_MAX_THR	6
#define SM_QMGR_MAX_FD	10

#endif /* SM_QMGRDEF_H */
