/*
 * Copyright (c) 2004 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 * $Id: ssdef.h,v 1.13 2004/11/19 22:14:09 ca Exp $
 */

#ifndef SM_SSDEF_H
#define SM_SSDEF_H 1

#include "sm/generic.h"
#include "sm/units.h"

/* policy milter: turned off by default; currently under development */
#ifndef SM_USE_PMILTER
# define SM_USE_PMILTER	0
#endif

/* SMTP Server Context configuration flags */
#define SSC_CFL_ACCESS_DB	0x0001u	/* use access map */
#define SSC_CFL_DELAY_CHKS	0x0002u	/* delay checks */
#define SSC_CFL_SPAM_FRIEND	0x0004u	/* spam friend feature */
#define SSC_CFL_SPAM_HATER	0x0008u	/* spam hater feature */
#define SSC_CFL_8BITMIME	0x0010u	/* offer 8BITMIME */
#define SSC_CFL_BACKGROUND	0x0020u	/* fork */
#define SSC_CFL_SERIAL_ACC	0x0040u	/* serialize accept */
#define SSC_CFL_SOFTBOUNCE	0x0080u	/* softbounce (replace 5xy with 4xy) */

/* do not consider lmtp: in mt as local wrt relaying */
#define SSC_CFL_LMTPNOTRELAY	0x0100u
#define SSC_CFL_PMILTER		0x1000u	/* use policy milter */

/* STARTTLS related options */
#define SSC_CFL_TLS_REL_VRFY	0x2000u	/* allow relaying if verified */
#define SSC_CFL_TLS_REL_ACC	0x4000u	/* check access map for relaying */

/* what should be done if pmilter fails? */
/* #define SSC_MFL_PM_IGN	0x00000001u	* ignore failure: default */
/* #define SSC_MFL_PM_TEMP	0x00000002u	* tempfail everything */
#define SSC_MFL_PM_421		0x00000004u	/* 421 ... */

/* Socket listen queue size */
#define LISTENQ_SIZE_DEFAULT 256

/* SMAR reply read timeout (in seconds) */
#define TMO_W4A2S	20

/* QMGR reply read timeout (in seconds) (too long?) */
#define TMO_W4Q2S	20

/* Milter reply read timeout (in seconds) */
#define TMO_W4M2S	20

/* I/O with SMTP client */
#define SS_IO_TIMEOUT 90

/* max. number of Received: headers (hops) */
#define SM_MAXHOPS 21

/* max. message size */
#define SM_MAX_MSG_SZ_KB	8 UNIT_MB

#define RELAY_CLT "127.0.0.1"
#define RELAY_RCPT "(^<postmaster>|@localhost>)$"

#endif /* SM_SSDEF_H */
