/*
 * Copyright (c) 2003 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: inout.c,v 1.2 2003/12/18 00:27:31 ca Exp $")

#include "sm/ctype.h"

#include <stdio.h>
#include <signal.h>

static int Verbose = 0;

int
main(int argc, char *argv[])
{
	int i;

	(void) signal(SIGPIPE, SIG_IGN);
	if (Verbose)
		fprintf(stderr, "in=%p, out=%p, err=%p\n",
			stdin, stdout, stderr);
	while ((i = getchar()) != EOF && i != 'z' && i != 'Z')
	{
		if (ISPRINT(i))
			putchar((char)i);
		else
			putchar('X');
		fflush(stdout);
	}
	fflush(stdout);
	return 0;
}
