/*
 * Copyright (c) 2004 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 * $Id: smtpsh.h,v 1.1 2004/10/15 20:33:42 ca Exp $
 */

#ifndef SMTPSH_H
#define SMTPSH_H 1

#include "sm/generic.h"
#include "sm/types.h"
#include "smtps-str.h"

/* size for SMTP communication buffers */
#define SMTPBUFSIZE	1024
#define SMTPMAXSIZE	4096
#define SMTPMSGIDSIZE	256

/* maximum number of arguments for commands */
#define SS_MAX_ARGS	8

extern sm_ret_T	 ss_hdl_session(ss_sess_P _sess, sm_ret_T _sessok);
extern sm_ret_T	 ss_sess_new(ss_ctx_P _ss_ctx, ss_sess_P *_pss_sess);
extern sm_ret_T	 ss_sess_free(ss_sess_P _ss_sess);

extern sm_ret_T ssm_mail_new(ss_ta_P _ss_ta, ss_mail_P *_pmail);
extern sm_ret_T ssm_mail_free(ss_ta_P _ss_ta, ss_mail_P _mail);
extern sm_ret_T ssr_rcpts_new(ss_ta_P _ss_ta, ss_rcpts_P _rcpts, ss_rcpt_P *_prcpt);
extern sm_ret_T ssr_rcpt_free(ss_ta_P _ss_ta, ss_rcpt_P _rcpt);
extern sm_ret_T ssr_rcpts_free(ss_ta_P _ss_ta, ss_rcpts_P _rcpts);
extern sm_ret_T ss_ta_clr(ss_sess_P _ss_sess, ss_ta_P _ss_ta);
extern sm_ret_T ss_ta_abort(ss_sess_P _ss_sess, ss_ta_P _ss_ta);
extern sm_ret_T ss_ta_init(ss_sess_P _ss_sess, ss_ta_P _ss_ta);

#endif /* SMTPSH_H */
